05/25/2004 (version 2.32)
----------
1. new option change_smbpasswd in auth_unix.conf.default
   (suggested by koach.AT.ccsh.kh.edu.tw)
2. fix a bug that the charset in message composing window would become none 
   after adding attachment
   (reported by Dominic Lu, dominic.AT.dominic.idv.tw)


05/21/2004
----------
1. new authentication module: auth_ldap_vpopmail.pl
   (thanks to Andrea Siviero, sivix.AT.users.sourceforge.net for his code)


05/19/2004
----------
1. fix the problem that update_folderindex() may generate index with
   zero or negative msg size in case the folder size is changed by
   other process that doesn't check filelock before writing.
   (thanks to James Briggs, james.AT.ActionMessage.com for providing the 
    detailed debugging information so many times, which were very helpful 
    in locating this problem)


05/17/2004
----------
1. fix a bug that first time user would see access error after saving the 
   preference if the webmail is not enabled for this user


05/14/2004
----------
1. remove the log_time from modules/mailparse.pl which would log debug info
   to /tmp/openwebmail.debug


05/13/2004
----------
1. fix a bug in module/mailparse.pl that doesn't handle boundary well
   if the boundary is not defined in quotes
   (reported by Bob Dobbs, beezleb0b.AT.users.sourceforge.net)


05/12/2004
----------
1. add support for text/enreiched content type
   The Apple Mail in OS X 10.3 generates messages of this content type
   (thanks to Bob Dobbs, beezleb0b.AT.users.sourceforge.net for 
    providing sample messages)
2. add support for GBK charset


05/11/2004
----------
1. Dutch language and templates minor update
   (thanks to Jeroen Visser, openwebmail.AT.forty-two.nl)
2. minor fix to openwebmail-send.pl to cut long smtp error message
   in writeing log


05/10/2004
----------
1. fix a bug in webdisk that passed variable $escapedfolder as string 
   'escapedfolder'
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)
2. new tool to create Cool3D icons for all languages: ut/mkcool3d.sh
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)


05/08/2004
----------
1. Hellenic/Greek language, holiday file and Cool3D.Hellenic iconset update
   add Hellenic charsets to openwebmail-spell.pl
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)
2. fix a bug in popup addressbook which didn't escape the undefined email
   in target field properly and caused strange output in the end of addressbook
   (reported by Carlos Pina Soares, cpsoares.AT.fcsh.unl.pt)
3. set $Carp::MaxArgNums to 0 in tool.pl so stacktrace() prints all arguments in 
   routine calls.
4. fix a bug in openwebmail-tool.pl which passed an array as array reference
   to getfolders()


05/07/2004
----------
1. use module Carp to do stack trace in case any invalid message attribute
   is written into folder db.


05/06/2004
----------
1. more check on pop3 quit command
   (thanks to Steve Bromwich, Steve.Bromwich.AT.impsolutions.com)
2. move argument of spellchecker from openwebmail-spell.pl to option 
   spellcheck in openwebmail.conf.default for better flexibility
3. fix a bug in stationery book that data is displayed in unescaped mode
   (reported by Thomas Chung, tchung.AT.openwebmail.org)


05/02/2004
----------
1. Hellenic/Greek language, holiday file and Cool3D.Hellenic iconset update
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)


05/01/2004
----------
1. minor fix to pop3.pl to wait confirmation of quit from server before 
   closing the connection
   (suggested by Dop Ganger, dopganger.AT.users.sourceforge.net)


04/30/2004
----------
1. improve mailparser to find lost MIME attributes in header for messages 
   resent from mailling list softwares (eg: mailman)
2. minor fix to start code of in openwebmail*pl to open /etc/openwebmail.conf,
   so it won't do unnecessary open()
3. code clean, use operator 'eq', 'ne' for null string test


04/29/2004
----------
1. minor fix to openwebmail-spellcheck.pl so empty personal dictionary
   will appear instead of error message "Couldn't open ... file" in case
   the user has not put any word in his personal dictionary
   (suggested by SuperLight, superlight.AT.cheyi.net)


04/28/2004
----------
1. support option check_expire in etc/auth_unix.conf
   (thanks to Luis Alberto Alegria De Los Santos, dsantos.AT.unach.mx for his patch)


04/27/2004
----------
1. fix a typo error in maildb.pl which made the msg count always one more 
   than the real count when doing the fast rebuild of db index.
   (reported by SuperLight, superlight.AT.cheyi.net)
2. Cool3D.Hellenic iconset update
   Hellenic/Greek holiday file
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)


04/25/2004
----------
1. fix a bug introduced by fix4 04/24/2005 which caused
   the 'Status: R' being added into msg header improperly.
2. roll the db version number for new msgheader length definition

ps: Sysadm may execute the following command to convert db for all users,
    this eliminates the possible delay caused by db conversion ar user access.

    /path_to_openwbemail/openwebmail-tool.pl -if -a 

3. Hellenic/Greek language translation update
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)


04/24/2004
----------
1. fix a bug in filelock.pl which tried to close opened file
   with wrong handle value in closeall() routine
   (reported by James Briggs, james.AT.ActionMessage.com)
2. Polish login.template minor update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)
3. fix a bug in openwbemail-send,pl which won't calc the header size and 
   header checksum for saved draft or sent message
4. minor fix to maildb.pl so the 1st nl of delim nlnl between msg header 
   and body is counted as part of message header
5. more check in mailfilter.pl to eliminate the 'filter i/o error' problem
   (reported by James Briggs, james.AT.ActionMessage.com)
6. improve markread routine in openwebmail-folder.pl


04/23/2004
----------
1. move openwebmail-tool.pl dbm_test() to dbm.pl guessoptions(),
   so all dbmopen/dbclose are handled by module dbm.pl.
2. Bulgarian language, templates translation update
   (thanks to Veselin Slavov, vess.AT.vess.bnc.bg)
3. display both sender and receiver email address when user puts the mouse 
   over the From field in folder view
4. insert a blank line to the end of a pop3 fetched message 
   if it is ended with empty line
   (reported by Owen Carter, sleasytarget.AT.users.sourceforge.net)


04/22/2004
----------
1. added explicit seek() to filelock.pl and openwebmail.pl after open with '<+'
2. changed LOGFILE open from '>>' to '<+' to help speedup NFS access
   in ow-shared.pl
3. removed folder update code from upgrade.pl 
   (folders now have their own version number and will be updated 
    automatically when opened)

ps: Thanks to Scott A. Mazur, scott.AT.littlefish.ca for all the above fixes.

4. improve the inlined object resolving for html attachments in mailparse.pl
5. check message size before reading in mailfilter.pl to avoid
   'Negative length at mailfilter.pl line 271' error
   (reported by James Briggs, james.AT.ActionMessage.com)
6. fix the bug in datetime.pl that timeoffset in date field would be wrong 
   in message composing when daylightsaving is active
   (reported by James Briggs, james.AT.ActionMessage.com)
7. minor fix to Secretaries' Day in en_US holiday file
   (thanks to James P. Dugal, jpd2.AT.users.sourceforge.net)
8. fix a bug in openwebmail.pl that auth pop3 won't delete the 
   mail on pop3 server even option authpop3_delmail is set to 'yes'


04/19/2004
----------
1. fix a bug in sub writehistory which always wrote new records at the 
   beginning of history.log
   (reported by Martin Och, ochm.AT.users.sourceforge.net)


04/18/2004
----------
1. fix a bug that autoreply with vacation.pl won't work under MTA exim
   because the | char was outside the quote in user .forward file
   (reported by Tobias, redshift17.AT.users.sourceforge.net)


04/17/2004
----------
1. code clean
   a. renamed several maildb.pl functions to be more readable.  
   b. replaced individual index split/join code with common call functions.  
   c. use '\n' as delimiter instead of old '@@@' in folderdb

ps: Sysadm may execute the following command to convert db for all users,
    this eliminates the possible delay caused by db conversion at user login.

    /path_to_openwbemail/openwebmail-tool.pl -i -a 

2. removed tell() function from all code (no more tell() warning).
3. reduced code with common address/stationary book read and write functions

ps: Thanks to Scott A. Mazur, scott.AT.littlefish.ca for all the above fixes.

4. fix a bug that 'replying with stationary' won't do charset conversion 
   correctly
5. Polish language and holiday file update
   (thanks to Mikolaj Menke, miki.AT.z.pl)


04/15/2004
----------
1. German Holiday file update
   (thanks to Grund Helmut RZ, Helmut.Grund.AT.fh-furtwangen.de)
2. Czech language, templates and holiday file update
   (thanks to Milan Kerslager, milan.kerslager.AT.pslib.cz)


04/14/2004
----------
1. fix a bug in filelock.pl that fd in %opentable was not released until
   the end of request. (the fd should be released at the end of lock)
   So if sysadm uses openwebmail-tool.pl -a -i to index folders of all users,
   all fds won't be released until folders of all users have been processed.
2. minor fix to htmlrender.pl for better rendering of html message and
   the referred inline attachments
3. fix the syntax error 'Argument "no" isn't numeric in numeric eq (==) at...'
   in ow-shared.pl
   (reported by CyberCytes, cybercytes.AT.users.sourceforge.net)
4. fix a bug in maildb.pl that gernerated wrong index for message with a
   long @@@@@@@@@@@ line in subject


04/13/2004
----------
1. fix the bug that changing calendar interval time to less than 30 minute 
   will affect the starthour in calendar
   (reported by jebright.AT.esisnet.com)
2. fix invalid html in openwebmail-main.pl which prevented openwebmail 
   from working on PocketPC2003/iPAQ2210
   (reported by Robert.Eckardt.AT.Robert-Eckardt.de)
3. fix a bug in auth_pop3.pl which called fetchmail() for authentication
   with wrong parameter
   (reported by Owm Fan, owmfan.AT.users.sourceforge.net)
4. add option session_count_display to openwebmail.conf to control
   whether to display number of active sessions in the past 1, 5, 15 minutes
   when user logins.
5. avoid forking multiple processes in pop3 fetching in openwebmail-tool.pl
   This is slower but much safer.
6. fix a bug in maildb.pl which fell into endless loop in some of the cases
   that if a 'From ' was found but not a message dilimeter.


04/12/2004
----------
1. check the existence of variable before doing undef() in 
   openwebmail_clearall() to fix the 
   'Attempt to free non-existent shared string ...' error
   (reported by Dugal James P., jpd.AT.louisiana.edu
                Peter Friedrich, peterf1972.AT.users.sourceforge.net)
2. fix a bug in update_folderindex() that tried to added a null record
   into the folder db
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
3. fix a bug that mail parser fell into the forever loop in dealing with
   null attachment block. this bug was introduced by the 20040408 fix 1
   (reported by chukk.AT.mail.tn.edu.tw) 
4. log the count of active sessions in past 1, 5, 15 minutes at user login,
   it can be used as a rough summary of the load of openwebmail


04/11/2004
----------
1. Portuguese Brazil language, template, htmlarea translation minor update
   (thanks to Julio Cesar Cunha, julio.AT.cnm.org.br)
2. better handling of db inconsistence.
   it should fix the 'mail filter i/o error' problem effectively.


04/10/2004
----------
1.  fix broken 'effectiveuser' paramater in auth_pop3.pl module
2.  fix broken index update code.  Index was being corrupted when
    folders were updated outside of OWM (POP3/IMAP access).  
    Added MD5 checksums of each message header to the index to ensure 
    message changes are not missed.
3.  Fixed bug in mail fiter smart filter code where filtered message was
    being copied to a new folder without first reading full original message.
    Minor changes to for error checking and better compatibility with new
    maildb.pl code.
4.  Fixed bug that config parameter enable_smartfilter was coded as enable_smartfilters
5.  Fixed bug that session file would not be untainted after vdomain actions.
6.  Removed 'ReturnPath' address from 'cc:' when reply to all.
7.  Replace webdisk button with webdisk icon in mail composer (eye candy).

ps: Thanks to Scott A. Mazur, scott.AT.littlefish.ca for all the above fixes!
    
Note:

1. Module Digest-MD5-2.33.tar.gz is required since this release.

2. The folder db format is changed since this release, 
   the system will do the conversion automatically when user logins on

3. Sysadm may execute the following command to convert the dbs for all users,
   this would eliminate the possible delay caused by the conversion at 
   user login.

   /path_to_openwbemail/openwebmail-tool.pl -i -a 


04/09/2004
----------
1. holiday file en_GB for British update
   (thanks to Gareth Horth, GHorth.AT.GJG.co.uk)
2. fix a security bug that arbitary directory could be created through web 
   interface if the option use_syshomedir is set to no or create_syshomedir 
   is set to 'yes'
   (reported by Eric Wheeler, ewheeler.AT.nsci.us)
3. Czech language file update
   (thanks to Milan Kerslager, milan.kerslager.AT.pslib.cz)


04/08/2004
----------
1. minor fix to mailparse.pl for better compatibility with abnormal mime 
   block
   (reported by chukk.AT.mail.tn.edu.tw) 
2. fix a bug that html2text() will remove the space chars betwen strings 
   if the space char is at the end of line in the source html.
   (reported by sistek.AT.sistek.com.ar)
3. filter messages with X-Spam-Level: ******** in mail header
   (this is to be used with system running Spamassassin :))


03/04/2004
----------
1. fix the bug that setting option enable_history to no won't stop the log of 
   user history


02/25/2004
----------
1. minor change to pop3.pl so less memory is used in fetching large message
2. fix a bug in mailfilter that duplicated messages in INBOX may be filtered 
   into target folder and had the message counter updated like they were
   different messages.


01/31/2004
----------
1. fix a bug that @@@STARTSPELLCHKECKFORM@@@ appeared at top in the message
   composing form when enable_spellcheck was set to no
   (reported by Mattijs Vreeling, mattgick.AT.users.sourceforge.net) 
2. fix a bug that cal-popup.gif was missing in all Adjunct iconsets
   (reported by Alex Teslik, ateslik.AT.users.sourceforge.net)
3. fix a type error in etc/lang/zh_TW.Big5
   (reported by Robert Chang, robertchang.AT.users.sourceforge.net) 
4. fix a bug that message with date larger than year 2037 would cause runtime
   error
   (reported by Technical Support, netfront.AT.users.sourceforge.net) 


01/27/2004
----------
1. fix a security hole that parameters were passed to userstat.pl 
   without shell escape char checking
   (thanks to Ken Girrard, kgirrard.AT.users.sourceforge.net for his fix)

ps: This userstat.pl is not used by openwbemail runtime system, 
    it is designed to query user mail/calendar status for static webpages.
    So if you don't want to upgrade your openwebmail, you may just remove 
    this userstat.pl as a workaround.

2. add md5 support to auth module auth_mysql.pl
   (thanks to Yuan-Chung Hsiao, ychsiao.AT.linux.mis.stu.edu.tw)
3. fix a bug that setting allowed_clientdomain or allowed_clientip to none 
   does work
   (thanks to Tom Smith, tomcyber.AT.users.sourceforge.net for his report)
4. new iconsets: Adjunct.Blue, Adjunct.Metal, Adjunct.Silver
   new style: Adjunct
   (thanks to Sergio Bukhgalter, sbukhgalter.AT.britishinstitute.it 
    who made these great icons loosely based on Ximian Gnome)


01/17/2004
----------
1. fix openwebmail-vdomain.pl to utilize the module/suid.pl
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


01/16/2004
----------
1. move euid/egid setting routines into modules/suid.pl

   Note!!
   The option has_savedsuid_support has been moved 
   from etc/openwebmail.conf.default to etc/suid.conf

2. load auth module into ow::auth::internal.
   and the routines in ow::auth are actually stub routines for the 
   counterpart in ow::auth::internal
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his code)
3. update zh_HK.Big5 holiday file, add en_HK holiday file
   (thanks to faifai.AT.users.sourceforge.net)


01/12/2004
----------
1. add SSL support for pop3 message retrival
   (thanks to Dao-hui Chen, dhchen.AT.dhchen.com for his patch)
2. fix a bug since openwebmail-2.30 that release.date file won't be 
   created for new user
3. add two options for authpop3: authpop3_delmail, authpop3_usessl
   and rename other pop3 related options
   disallowed_pop3servers ->		pop3_disallowed_servers
   delpop3mail_by_default ->		pop3_delmail_by_default
   delpop3mail_hidden ->		pop3_delmail_hidden
   usepop3ssl_by_default ->		pop3_usessl_by_default
   pop3_authserver ->			authpop3_server
   pop3_authport ->			authpop3_port
   getmail_from_pop3_authserver -> 	authpop3_getmail


01/10/2004
----------
1. add auth.pl as the parent package ow::auth for all auth modules.
   add quota.pl as the parent package ow::quota for all auth modules.
2. Serbian language and template files translation update
   (thanks to Aleksandar Pejic, alexa.AT.yunord.net)
3. fix a bug that openwebmail-vdomain.pl could not read the virtual user
   passwd or release file.
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
4. fix the problem that from.book for old vdomain user could not be found
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


01/05/2004
----------
1. fix a bug that a file will be counting as folder twice if it is happened
   to be the mailspool file.
   (reported by Karim Nasser, slashproc.AT.users.sourceforge.net)
2. minor optimization for log message list and long filelist
3. fix a bug that some options in preference could not be unchecked or set 
   to null
   (reported by ¼B«H§g, s2323540.AT.ncnu.edu.tw)


01/04/2004
----------
1. fix a bug that webdisk won't work if openwebmail.conf option logfile 
   is set to none
   (suggested by Vicente Chua, chuavv.AT.mail.savs.hcc.edu.tw)
2. add long page support to message list
   (suggested by Pat Hagge, maxrebo82.AT.users.sourceforge.net)
3. fix a bug that filterrule with action to move messages to INBOX will 
   actually erase the matched messages instead :(
   (reported by ¼B«H§g, s2323540.AT.ncnu.edu.tw)


01/03/2004 (version 2.30)
----------
1. Portuguese Brazil language, template, htmlarea translation minor update
   (thanks to Julio Cesar Cunha, julio.AT.cnm.org.br)
2. fix a bug that user preference could not be saved
ps:2.30 is released again because of this bug...
3. Italian language and templates translation minor update
   (thanks to Marvi Benedet, marvi.AT.menhir.biz)
4. fix a bug that template tag @@@DELPOP3STRSTART@@@ was not cleaned in 
   editpop3


01/02/2004
----------
1. new option enable_spellcheck in openwebmail.conf.default
   prefs.template translation update
   (thanks to Tamas R., freddy.AT.lamer.hu for his patch and update)
2. Polish prefs.template minor update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)


01/01/2004
----------
1. code clean for datetime routines
2. simplify the user preference for first time login user


12/31/2003
----------
1. fix a bug in copying/moving to a destination folder which set the metainfo
   of a folder before the folder is closed.
2. Spanish language and template files translation minor update
   (thanks to Javier Smaldone, jsmaldone.AT.yahoo.com)
3. Thai template and htmlarea files translation update
   (thanks to Atsawin Chaowanakritsanakul, joke.AT.nakhon.net)
4. New mirror site at San Diego, CA, US
   http://openwebmail.mirrors.redwire.net
   (thanks to Japheth Cleaver in Redwire Broadband, mirror.AT.redwire.net)


12/27/2003
----------
1. Bulgarian language, template, htmlarea translation minor update
   (thanks to Veselin Slavov, vess.AT.vess.bnc.bg)
2. improve compatibility with bad implemented pop3 server(e:gnu-pop3d) 
   that doesn't support both LAST and UIDL command
   (reported by Jesse, 0947111446.AT.pchome.com.tw)


12/19/2003
----------
1. fix the bug that 'block smtprelay' and 'block email' in readmessage won't work
   (reported by zahari, mrzahz.AT.users.sourceforge.net)
2. fix the bug that all domains always reference the main templates even the 
   domain has defined its down template path
   (reported by zahari, mrzahz.AT.users.sourceforge.net)
3. Polish prefs.template minor update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)
4. add option webdisk_symlinkout_display to control the display of symlinkout
   dirname or filename
   (suggested by Ken Tan, spider369.AT.users.sourceforge.net)
5. fix a bug in addressbook that invalid regex would cause error
   (thanks for Tamas Reinhardt, freddyke.AT.users.sourceforge.net for his patch)
6. fix a bug that message with empty body won't be correctly indexed if it 
   appears at the end of folder
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
7. Norwegian language and templates translation update
   (thanks to Are Tysland, are.AT.valinor.dolphinics.no)


12/18/2003
----------
1. use open(F, "+<filename");seek(F,0,2); instead of open(F, ">>filename");
   As the later one is unbuffered, which imples a very big impact on file
   write over NFS. In our testing, the time of copying a 15MB file over NFS
   is reduced from 67 sec to 0.7 sec, the speedup is about 95x. :)
 
   So we highly recommend systems running Open WebMail over NFS upgrade to 
   this releae as soon as possible.

2. French language and template files update
   (thanks to Nabil SEFRIOUI, admin.AT.osmium-work.com)
3. Hungarian language file update
   (thanks to Posz Marton, ful_s.AT.fazekas.hu)
4. minor optiomization for users that set default charset to utf-8


12/17/2003
----------
1. fix a bug in webdisk that thumbnail timestamp was not kept the same as 
   original image.
2. fix a bug in folderindex() wich could the status of a message to the next one
   (reported by Raj Agarwal, ragarwal.AT.integ.com)
3. fix a typo error in auth_nis.pl.
   (reported by Vladimir M Costa, vlad.AT.univap.br)


12/16/2003
----------
1. minor optimization to mailfilter module
2. fix a bug that old mesages won't be zapped when user tries
   to save same message into the draft folders.
3. msword document preview support in message read, composing and webdisk


12/15/2003
----------
1. list www.postman.net as the online demo site for openwebmail
   (thanks to Arthur Corliss, admin.AT.postman.net)
2. change global filter rule from X-Mailer: [a-z]+$ to 
   X-Mailer: [a-z]{6,}$ so messages generated by PHP webmail won't be
   filtered
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
3. fix a bug that the content of message/rfc822 attachment will become 
   "snipped..."
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
4. fix a bug that attachment won't be decoded correctly 
   when user choose to download it.
5. add DHTML popup calendar support to openwebmail-cal.pl
   (thanks to Alex Teslik, ateslik.AT.users.sourceforge.net for his patch)


12/14/2003
----------
1. fix a bug that subject in folder view will become 'N/A'
2. heavy code clean
3. change option default_disablejs      from 'no' to 'yes'
                 default_disableemblink from 'none' to 'cgionly'
   add option default_disableembcode and set it to yes.

ps:These above options are useful in filtering malicious code 
   in html message. Please refer to the following URL for more detail
   http://www.kb.cert.org/vuls/id/707100 and 
   http://www.cert.org/advisories/CA-2000-02.html 
   (reported by James Briggs, james.AT.ActionMessage.com)


12/12/2003
----------
1. fix a javascript bug in mailfilter editing
   (reported by James Briggs, james.AT.ActionMessage.com)
2. fix fast msg end check code so it can work with new indexing routine.
3. Spanish language and template files translation update
   (thanks to Javier Smaldone, jsmaldone.AT.yahoo.com)


12/11/2003
----------
1. code clean and BIG performance improvement!
   The folder indexing speed is about 300% to 1000% faster :)
   The mail filtering speed is about 30% faster

   NOTICE!!!

   The dbm options (dbm_ext, dbmopen_ext and dbmopen_haslock) 
   have been moved from etc/openwebmail.conf to etc/dbm.conf.default
   And you may get value for your etc/dbm.conf by running
   
   perl uty/dbmtest.pl

   The use_doctlock option has been moved from etc/openwebmail.conf
   to filelock.conf.default. You may have your own filelock.conf too.

ps:If you are running openwebmail in persistent mode,
   don't forget to 'touch openwebmail*.pl' after making modification
   to dbm.conf or filelock.conf, so speedycgi knows to reload all the
   scripts, modules and conf files in --init.
 
2. filelock option is moved from etc/openwebmail.conf 
   to etc/filelock.conf and etc/filelock.conf.default
   dbm options are moved from etc/openwebmail.conf 
   to etc/dbm.conf and etc/dbm.conf.default
3. add export addressbook support for pine
   (thanks to Matt Roberts, matt.AT.dworkin.org for his code)
4. sort filterrules in the following order explicitly when doing filtering
   priority (small first)
   action (copy first, then move)
   destination folder (INBOX, regular folders, then mail-trash, DELETE)
   rule type (from, to, subject, header, smtprelay, attfilename, textcontent)
5. fix minor bug in mailfilter which passed parameters in wrong order
6. fix minor bug in mailfilter that text content matching in message body 
   always failed
7. fix a typo error in quota_du.pl
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
8. fix a bug that folderlist cache is always missed
9. fix db initial error in openwebmail-tool.pl --init
   (reported by Dominic Lu, dominic.AT.dominic.idv.tw)
10.document correction for the new dbm.conf and filelock.conf
   

12/04/2003
----------
1. catalan language and template files major update
   (thanks to Jordi Sanfeliu, mikaku.AT.fiwix.org) 
2. rename uty/speedy2suidperl to uty/speedy_suid2suidperl
          uty/suidperl2speedy to uty/suidperl2speedy_suid
   and the suid speedy wrapper is assumed to be /usr/local/bin/speedy_suid
3. log action of listarchive, editfile and uploadfile in webdisk
4. fix to openwebmail-vdomain.pl and vdomain related tools under uty/
   for new dotpath routines.
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
5. rename a webdisk file from basename.ext to basename.0.ext 
   if the uploaded file has the same filename basename.ext


12/02/2003
----------
1. rename etc/auth_xxx.conf to etc/auth_xxx.conf.default
   And each auth module will read etc/auth_xxx.conf first,
   If auth_xxx.conf is not available, then read auth_xxx,conf.default instead
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


12/01/2003
----------
1, fix a bug in openwebmail-abook.pl that email address was not escaped
   when invoking mail composer
   (reported by Scott A. Mazur, scott.AT.littlefish.ca)
   

11/30/2003
----------
1. minor change to semantic of 'search by subject' in folder view
   In addition to matching by subject, the search will find all related 
   thread by analyzing messageids in the references field
2. move auth*.conf from auth/ to etc/ so all conf file are within 
   same directory
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)
3. new option in user preference to control whether to display 
   mini search icon in folder view


11/29/2003
----------
1. fix a bug that option auto_createrc in openwebmail.conf won't work
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
2. minor change to about.template
3. fix to openwebmail-vdomain.pl
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca)
4. fix a bug that the first attachment in message will be not correctly 
   showed as an embedded image
5. add small search icon in 'to' and 'subject' field in folder view
   (suggested by James Briggs, james.AT.ActionMessage.com)
6. new holiday file ja_JP.Shift_JIS
   (thanks to James Briggs, james.AT.ActionMessage.com)


11/28/2003
----------
1. BIG CHANGE!!! Old openwebmail stored internal files in ~username/mail/ 
   with filename with leading dot (.xxx)
   This release stores internal files in ~username/.openwebmail/ instead.
2. new option homedirdotdirname
   This is the name of directory that contains openwebmail internal files
   The default is .openwebmail
3. new option use_syshomedir_for_dotdir
   If this option is set to 'no', then .openwebmail directory will be put into
   cgi-bin/openwebmail/etc/users/username/ instead of ~username/.openwebmail/

ps:Original internal files in ~username/mail/ will be moved into 
   ~username/.openwebmail/ automatically after user login or 
   openwebmail-tool.pl check.

4. fix a "undefined dateserial2gmtime" bug in openwebmail.pl 
5. fix a bug in mailfilter that regular expression was used as normal text 
   for matching


11/27/2003
----------
1. fix bug related to thumbnail that untaint function was called 
   without specifying the ow::tool:: package name
2. fix a bug that openwebmail-tool.pl called the mailfilter() routine 
   with wrong number of paramters
3. fix the undefined main::get_info_messageids_sorted_by_date bug
   in openwebmail-advsearch.pl 


11/26/2003
----------
1. move auth_xxx.pl into auth/ and quota_xxx.pl into quota/
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)
2. move global setting in auth_xxx.pl into auth_xxx.conf
   so no more change to script itself is required for different cases.

Note: If your openwebmail is running in persistent mode,
      you have to execute 'touch openwebmail*pl' in cgi-bin/openwebmail/
      after the auth_xxx.conf is modified, or the it won't be reloaded.

ps: It is highly recommended to remove old openwebmail before installing this
    one, or you will have some stale files in cgi-bin/openwebmail/modules
    All data format are the same, there should be no danger to upgrade. :)


11/25/2003
----------
1. rename filter_badformatfrom t filter_badaddrformat in preference
   It filters messages with email addresses in bad format
2. New mirror site at Nashua, NH, USA
   http://openwebmail.nobandwidth.net 
   (thanks to John Cole, elonex.AT.kirkwor.com)


11/22/2003
----------
1. insert \n for long html lines before passing html to the composer
   or the width of html message composer may not fit within screen resolution
2. fix the bug in uty/iconv.pl.fake that it could not find iconv-chinese.pl 
   and iconv-japan.pl
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
3. Polish language, prefs.template and htmlarea-lang.js minor update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)
4. mirror site openwebmail.insecure.pl changed its name to 
   openwebmail.ippartners.pl
5. fix "Undefined subroutine &main::encode_base64" error in pop3book.pl


11/20/2003
----------
1. move non folder format related code out from maildb.pl
2. fix a type error in $ENV cleanup that the BASH_ENV was written as BASHENV.
   (reported by Dea, dea.AT.lamp.polito.it)


11/19/2003
----------
1. rearrange the hierarchy of script files
   a. package name for auth module, quota module and language files
      is changed from openwebmail:: to ow::
   b. all module files are moved into cgi-bin/openwebmail/modules
      (module means the script has its own package name like ow:xxx)
   c. all shared files are moved into cgi-bin/openwebmail/shares
   d. split code from maildb.pl/ow-shared.pl into new shared fils or modules

   This new one is much modular than before and should be faster

ps: It is highly recommended to remove old openwebmail before installing this
    new one, or you will have some stale script files in cgi-bin/openwebmail/
    All data format are the same, there should be no danger to upgrade. :)


11/18/2003
----------
1. fix some file permissions under data/
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca)
2. Ukrainian language and template translation minor update
   add UK holiday file
   (thanks to Volodymyr M. Lisivka, lvm.AT.mystery.lviv.net)
3. fix minor bug that space char in mimewords was not properly 
   encoded/decoded
   (reported by Volodymyr M. Lisivka, lvm.AT.mystery.lviv.net)


11/17/2003
----------
1. rename option savedsuid_support to has_savedsuid_support
   old name is still valid for backward compatibility.
2. fix the insecure $ENV{IFS} problem
   (reported by RJ Ent ,unixabg.AT.users.sourceforge.net)
3. better UI for duplicated mis-spelled words in openwebmail-spell.pl,
   only one dropdown menu will be used for same word correction.
4. add options webdisk_allow_untar, webdisk_allow_unzip, webdisk_allow_unrar
   webdisk_allow_unarj, webdisk_allow_unlzh to openwebmail.conf.default
   (suggested by David Mazieres, sfxxx.AT.users.sourceforge.net)


11/16/2003
----------
1. improve the speed of spellchck by using a mem dic and
   caching check result


11/15/2003
----------
1. fix a bug in openwebmail-vdomain.pl that getgrname won't return gid 
   if it is used as a string parameter
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
2. check failure of spell personal dictionary open
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
3. use routine hiddens() instead of the CGI.pm hidden() routine.
   This saves us 580 lines of redundant code :)
4. fix a bug in folder view that the search result won't be properly cached.
5. instead of creating pdic to eliminate startup error msg,
   openwebmail-spell.pl now ignores the error returned by pipeopen()
   if the spellchecker is started up properly
6. Thai language and templates translation minor update
   (thanks to Atsawin Chaowanakritsanakul, joke.AT.nakhon.net)


11/14/2003
----------
1. Indonesian language and template translation update
   (thanks to James Briggs, james.AT.ActionMessage.com)
2. minor fix to openwebmail-spell.pl for less cpu usage
3. fix the bug in openwebmail-spell.pl that words were saved into 
   personal dictionary properly, but the won't be loaded by spellchecker 
   in next check.
ps:the personal dictionary will be set to the spellchecker default now
   (.ispell_words for ispell, .aspell.english.pws for aspell)
4. minor change to openwebmail-tool.pl to remove duplicated code
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


11/13/2003
----------
1. rewrite pipe code of openwebmail-spell.pl to make it more error friendly.
2. fix a bug in new pipecode that word correction menu may appear in wrong
   place on slow machine.
3. change personal dictionary to ~/mail/.ow.$spellcheckname.$dictionaryname
   so the personal dict in openwebmail won't be shared with other application.
4. change param('xxx') to param('xxx')||'' in variable assignment
   or passing multiple parameters may fail because of null value
5. fix a javascript bug in openwebmail-send.pl which prevented the
   'auto-saving composed message to draft folder' from working


11/12/2003
----------
1. fix a bug that block tags options in openwebmail.conf won't accept 
   null values
   (reported by Florian Effenberger, floeff.AT.arcor.de)


11/11/2003
----------
1. clean code related to update_virtusertable() and 
   rename it to update_virtuserdb()
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his code)
2. optional phone input table display in composemessage for big5 charset users


11/10/2003 (version 2.21)
----------
1. put 2.21 as a major bug fixed release
   for "Insecure dependence" error on some platform with new perl 5.8.x
   The error is fixed by using untaint() routine instead of direct untainting


11/09/2003
----------
1. play sound "you have new mail" only once for new messages
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
2. put more options into none_item processing
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


11/08/2003
----------
1. fix a bug in new readocnf code that language andy logindomain
   wouldn't change once a user have loginned in
2. fix a bug that vusers define in option localusers list won't be counted
   in openwebmail-tool.pl -a
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
3. fix the bug that some options with auto value were not properly initialized
4. minor speedup by caching all conf file in memory
5. holiday file en_GB for British update
   (thanks to Gareth Horth, GHorth.AT.GJG.co.uk)


11/07/2003
----------
1. minor speedup with great improved readconf() routine and openwebamil-tool.pl
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his great work)
2. use a new routine untaint() to untaint most variables.
   Perl behaves strangely sometimes if we use regex to untaint variable
   directly too many times. And use of this routine fixes the problem.
3. new debug routine refdump()
4. fix a bug that comma would be striped out from email address in
   addressbook editing, which prevented the user to input group mail address.
   (reported by Marcel Weber)
5. use $SIG{'CHLD'}='IGNORE' instead of $SIG{'CHLD'}=sub { wait; };
   so persistent process keeps alive after the child process terminates.
   This should speedup the readmessage quit a lot on slow machines.


11/06/2003
----------
1. new auth module: auth_nis.pl
  (thanks to Vladimir M Costa, vmcosta.AT.spamcop.net for his code)


11/05/2003
----------
1. turn page textfield in message list into dropdown menu
2. openwebmail-tool.pl -a now tries to scan all users under all domains
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)


11/04/2003
----------
1. better page control in folder view
2. add gotop icon in both folder view and readmessage
   (suggested James Briggs, james.AT.ActionMessage.com)
3. fix a bug that option enable_loadfrombook, enable_editfrombook didn't work
   (reported by Mike Harness, mharness.AT.users.sourceforge.net)


11/02/2003
----------
1. always show charset drop-down menu in readmessage()
   (suggested by Vicente Chua, chuavv.AT.mail.savs.hcc.edu.tw)
2. new iconset: Cool3D.Korean
   (thanks to Youngho Kang, ykang.AT.deskweb.net)


11/01/2003
----------
1. Indonesian language and template translation update
   (thanks to James Briggs, james.AT.ActionMessage.com)
2. improved html2text() in htmltext.pl


10/31/2003
----------
1. change background color for foldernames in dropdown menu in folder view
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)
2. set the font color of calendar reminder with style sheet instead of
   hard coded value
   (suggested by Ham MI-IH, Torsten Brumm, torsten.AT.torsten-brumm.de)
3. improved html2text() in htmltext.pl


10/29/2003
----------
1. fix a bug in openwebmail.pl that caused a forever loop page redirection
   between openwebmail.pl and start_url
   (reported by Scott A. Mazur, scott.AT.littlefish.ca)
2. change the color for folders in dropdown menu in folder view
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)


10/27/2003
----------
1. fix a bug in is_dst() in ow-shared.pl that caused the daylight-saving time
   auto switch error. The month returned by gmtime() is 0..11, not 1..12.
   (reported by James Briggs, james.AT.ActionMessage.com,
                 Martin Gignac, lmcgign.AT.mpbn.ericsson.ca)
2. fix a bug in openwebmail-abook.pl that & char will be stripe out from
   email address when adding new entry to addressbook
   (reported by Scott A. Mazur, scott.AT.littlefish.ca)
3. add option mailsentwindowtime option to user preference to control
   the use of mail sent notification window.


10/26/2003
----------
1. fix a bug in ow-share.pl which prevented the options
   enable_loadfrom, enable_editfrom, frombook_for_realname_only from working
   (reported by Thomas Chung, tchung.AT.openwebmail.org)


10/24/2003
----------
1. support ps2pdf, pdf2ps in webdisk
2. better display of search result in webdisk


10/23/2003
----------
1. change options in openwebmail.conf.default
   remove: enable_setfrom, enable_setfromemail
   add:    enable_loadfrombook, enable_editfrombook, frombook_for_realname_only
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)


10/22/2003
----------
1. New mirror site at Florida, USA
   http://unixnetworks.org/openwebmail/
   (thanks to Jonny Elonex, elonex.AT.kirkwor.com)
2. fix a bug in delete_vuser() in openwebmail-vdomain.pl
   (thanks to Antonio Godinho, godinho.AT.itcom.co.mz for his fix)
3. change permission of the directory
   cgi-bin/openwebmail/etc/users/
   cgi-bin/openwebmail/etc/sessions/
   from 770 to 771.
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)
4. fix the bug that "move to trash" button shows "over quota"
   instead of deleting message when user is over quota.
   (reported by Mike Fahey, mfahey.AT.enter.net)
5. handle mime words in a plain text message
ps:This happens if a mail client that doesn't know MIME tries to
   forward/reply/include a message sent from a MIME compliant client


10/20/2003
----------
1. use boldtext for folders with new messages and
   use grey text for folders without newmessages
   in folder select dropdown menu


10/18/2003
----------
1. fix a minor bug in el/login.template
   (reported by Dieter Schicker, dilino.AT.users.sourceforge.net)


10/17/2003
----------
1. add 'smartfilter_bypass_goodmessage' option to openwebmail.conf.default


10/15/2003
----------
1. minor optimization to is_dst() routine
   show user timeoffset in title bar
2. add shortcut key help in HtmlArea editor


Below are brief descriptions for versions before 2.20.
To get more detail, please refer to changes.txt in version 2.20

10/14/2003 (version 2.20)	enhanced virtual user control
06/17/2003 (version 2.10)	html composing, http compression support
03/25/2003 (version 2.00)	speedycgi support
02/12/2003 (version 1.90)	webdisk support
11/22/2002 (version 1.80)	iconv support
07/12/2002 (version 1.70)	calendar support
01/24/2002 (version 1.60)	send mail though SMTP server
10/31/2001 (version 1.50)	introduce pure text openwebmail.conf
08/16/2001 (version 1.40)	split authentication into modules
06/18/2001 (version 1.30)	support sendmail virtual user, autoreply
06/07/2001 (version 1.20)	support spell checking
04/26/2001 (version 1.10)	support save draft, confirm reading
03/02/2001 (version 1.00)	support pop3, mailfilter
				support uuencoded attachment
				support html message display
				support message search
				speedup access with dbm
09/14/2000 (neomail 1.14)	first test drive

